#![feature(slice_group_by)]

use itertools::Itertools;
use itertools::sorted;
use std::fs;
use anyhow::Result;


fn main() -> Result<()> {
    let input = fs::read_to_string("input/01.txt")?;

    let groups = input
        .split("\n").collect::<Vec<&str>>()
        .into_iter()
        .group_by(|ell| *ell != "");

    let elves: Vec<i32> = groups
        .into_iter()
        .filter(|(key, _)| *key)
        .map(|(_, elf)| elf
            .into_iter()
            .map(|val| val.parse::<i32>().unwrap())
            .sum()
        ).collect();

    let highest = sorted(elves);
    let sum: i32 = highest
        .into_iter()
        .rev()
        .take(3)
        .sum();
    println!("{:?}", sum);

    return Ok(());
}
